Index: cpukit/score/src/threadinitialize.c
===================================================================
--- cpukit/score/src/threadinitialize.c	(revision 07dc9709a42b41e542ce955f0c4fc02967f901e5)
+++ cpukit/score/src/threadinitialize.c	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -41,14 +41,19 @@
 )
 {
-  size_t               actual_stack_size = 0;
-  void                *stack = NULL;
-  #if ( CPU_HARDWARE_FP == TRUE ) || ( CPU_SOFTWARE_FP == TRUE )
-    void              *fp_area;
-  #endif
-  void                *sched = NULL;
-  void                *extensions_area;
-  bool                 extension_status;
-  int                  i;
-  uintptr_t            tls_size = (uintptr_t) _TLS_Size;
+  size_t     actual_stack_size = 0;
+  void      *stack = NULL;
+  #if ( CPU_HARDWARE_FP == TRUE ) || ( CPU_SOFTWARE_FP == TRUE )
+    void    *fp_area;
+  #endif
+  void      *sched = NULL;
+  void      *extensions_area;
+  bool       extension_status;
+  int        i;
+
+  /*
+   * Do not use _TLS_Size here since this will lead GCC to assume that this
+   * symbol is not 0 and the later > 0 test will be optimized away.
+   */
+  uintptr_t  tls_size = (uintptr_t) _TLS_BSS_end - (uintptr_t) _TLS_Data_begin;
 
 #if defined( RTEMS_SMP )
Index: testsuites/sptests/Makefile.am
===================================================================
--- testsuites/sptests/Makefile.am	(revision 07dc9709a42b41e542ce955f0c4fc02967f901e5)
+++ testsuites/sptests/Makefile.am	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -31,4 +31,5 @@
     spcbssched01 spcbssched02 spcbssched03 spqreslib sptimespec01 \
     spregion_err01 sppartition_err01
+SUBDIRS += sptls03
 SUBDIRS += spcpucounter01
 if HAS_CPLUSPLUS
Index: testsuites/sptests/configure.ac
===================================================================
--- testsuites/sptests/configure.ac	(revision 07dc9709a42b41e542ce955f0c4fc02967f901e5)
+++ testsuites/sptests/configure.ac	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -37,4 +37,5 @@
 # Explicitly list all Makefiles here
 AC_CONFIG_FILES([Makefile
+sptls03/Makefile
 spcpucounter01/Makefile
 sptls02/Makefile
Index: testsuites/sptests/sptls01/init.c
===================================================================
--- testsuites/sptests/sptls01/init.c	(revision 07dc9709a42b41e542ce955f0c4fc02967f901e5)
+++ testsuites/sptests/sptls01/init.c	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -25,4 +25,8 @@
 static __thread volatile char tls_item = 123;
 
+static volatile int read_write_small = 0xdeadbeef;
+
+static const volatile int read_only_small = 0x601dc0fe;
+
 static void check_tls_item(int expected)
 {
@@ -37,17 +41,20 @@
   check_tls_item(123);
 
-	sc = rtems_event_transient_send(master_task);
-	rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+  sc = rtems_event_transient_send(master_task);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
-	sc = rtems_task_suspend(RTEMS_SELF);
-	rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+  sc = rtems_task_suspend(RTEMS_SELF);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 }
 
 static void test(void)
 {
-	rtems_id id;
-	rtems_status_code sc;
+  rtems_id id;
+  rtems_status_code sc;
 
-	master_task = rtems_task_self();
+  master_task = rtems_task_self();
+
+  rtems_test_assert(read_write_small == 0xdeadbeef);
+  rtems_test_assert(read_only_small == 0x601dc0fe);
 
   check_tls_item(123);
@@ -55,21 +62,21 @@
 
   sc = rtems_task_create(
-		rtems_build_name('T', 'A', 'S', 'K'),
-		RTEMS_MINIMUM_PRIORITY,
-		RTEMS_MINIMUM_STACK_SIZE,
-		RTEMS_DEFAULT_MODES,
-		RTEMS_DEFAULT_ATTRIBUTES,
-		&id
-	);
-	rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+    rtems_build_name('T', 'A', 'S', 'K'),
+    RTEMS_MINIMUM_PRIORITY,
+    RTEMS_MINIMUM_STACK_SIZE,
+    RTEMS_DEFAULT_MODES,
+    RTEMS_DEFAULT_ATTRIBUTES,
+    &id
+  );
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
-	sc = rtems_task_start(id, task, 0);
-	rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+  sc = rtems_task_start(id, task, 0);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
-	sc = rtems_event_transient_receive(RTEMS_WAIT, RTEMS_NO_TIMEOUT);
-	rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+  sc = rtems_event_transient_receive(RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
-	sc = rtems_task_delete(id);
-	rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+  sc = rtems_task_delete(id);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
   check_tls_item(5);
Index: testsuites/sptests/sptls03/Makefile.am
===================================================================
--- testsuites/sptests/sptls03/Makefile.am	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
+++ testsuites/sptests/sptls03/Makefile.am	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -0,0 +1,19 @@
+rtems_tests_PROGRAMS = sptls03
+sptls03_SOURCES = init.c
+
+dist_rtems_tests_DATA = sptls03.scn sptls03.doc
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
+
+AM_CPPFLAGS += -I$(top_srcdir)/../support/include
+
+LINK_OBJS = $(sptls03_OBJECTS)
+LINK_LIBS = $(sptls03_LDLIBS)
+
+sptls03$(EXEEXT): $(sptls03_OBJECTS) $(sptls03_DEPENDENCIES)
+	@rm -f sptls03$(EXEEXT)
+	$(make-exe)
+
+include $(top_srcdir)/../automake/local.am
Index: testsuites/sptests/sptls03/init.c
===================================================================
--- testsuites/sptests/sptls03/init.c	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
+++ testsuites/sptests/sptls03/init.c	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2014 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+#ifdef HAVE_CONFIG_H
+  #include "config.h"
+#endif
+
+#include <rtems/score/thread.h>
+
+#include "tmacros.h"
+
+static volatile int read_write_small = 0xdeadbeef;
+
+static const volatile int read_only_small = 0x601dc0fe;
+
+static void test(void)
+{
+  Thread_Control *executing = _Thread_Get_executing();
+
+  rtems_test_assert(read_write_small == 0xdeadbeef);
+  rtems_test_assert(read_only_small == 0x601dc0fe);
+
+  rtems_test_assert(executing->Start.tls_area == NULL);
+}
+
+static void Init(rtems_task_argument arg)
+{
+  puts("\n\n*** TEST SPTLS 3 ***");
+
+  test();
+
+  puts("*** END OF TEST SPTLS 3 ***");
+
+  rtems_test_exit(0);
+}
+
+#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+
+#define CONFIGURE_MAXIMUM_TASKS 1
+
+#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
Index: testsuites/sptests/sptls03/sptls03.scn
===================================================================
--- testsuites/sptests/sptls03/sptls03.scn	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
+++ testsuites/sptests/sptls03/sptls03.scn	(revision 95d0c98cac5000da7f4f1fdd52299224b2f94235)
@@ -0,0 +1,2 @@
+*** TEST SPTLS 3 ***
+*** END OF TEST SPTLS 3 ***