Index: bsps/sparc/erc32/gnatsupp/gnatsupp.c
===================================================================
--- bsps/sparc/erc32/gnatsupp/gnatsupp.c	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
+++ bsps/sparc/erc32/gnatsupp/gnatsupp.c	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
@@ -0,0 +1,24 @@
+/**
+ * @file
+ *
+ * @ingroup sparc_erc32
+ *
+ * @brief Support for gnat/rtems interrupts and exception handling
+ */
+
+/*
+ * COPYRIGHT (c) 1999.
+ * European Space Agency.
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#include <bsp/gnatcommon.h>
+
+void
+__gnat_install_handler (void)
+{
+  __gnat_install_handler_common (0x1d, 0x15);
+}
Index: bsps/sparc/leon2/gnatsupp/gnatsupp.c
===================================================================
--- bsps/sparc/leon2/gnatsupp/gnatsupp.c	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
+++ bsps/sparc/leon2/gnatsupp/gnatsupp.c	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
@@ -0,0 +1,30 @@
+/**
+ * @file
+ *
+ * @ingroup sparc_leon2
+ *
+ * @brief Support for gnat/rtems iterrupts and exception handling
+ */
+
+/*
+ * COPYRIGHT (c) 1999.
+ * European Space Agency.
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ *
+ */
+
+#include <bsp/gnatcommon.h>
+
+/*
+ *  Avoid trap 0x18 which is used by the clock tick, and
+ *  0x12 (UART B interrupt) which is used by the stub.
+ */
+
+void
+__gnat_install_handler (void)
+{
+  __gnat_install_handler_common (0x18, 0x12);
+}
Index: bsps/sparc/leon3/gnatsupp/gnatsupp.c
===================================================================
--- bsps/sparc/leon3/gnatsupp/gnatsupp.c	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
+++ bsps/sparc/leon3/gnatsupp/gnatsupp.c	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
@@ -0,0 +1,30 @@
+/**
+ * @file
+ *
+ * @ingroup sparc_leon3
+ *
+ * @brief Support for gnat/rtems interrupts and exception handling
+ */
+
+/*
+ * COPYRIGHT (c) 1999.
+ * European Space Agency.
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ *
+ */
+
+#include <bsp/gnatcommon.h>
+
+/*
+ *  Avoid trap 0x18 which is used by the clock tick, and
+ *  0x12 (UART B interrupt) which is used by the stub.
+ */
+
+void
+__gnat_install_handler (void)
+{
+  __gnat_install_handler_common (0x18, 0x12);
+}
Index: c/src/lib/libbsp/sparc/erc32/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/erc32/Makefile.am	(revision 1efa1c8389604dcf303b9acfa26c0ae60db9d9b4)
+++ c/src/lib/libbsp/sparc/erc32/Makefile.am	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
@@ -36,5 +36,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/shared/start/bsp_fatal_halt.c
 # gnatsupp
-librtemsbsp_a_SOURCES += gnatsupp/gnatsupp.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/erc32/gnatsupp/gnatsupp.c
 librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/shared/gnatcommon.c
 # console
Index: src/lib/libbsp/sparc/erc32/gnatsupp/gnatsupp.c
===================================================================
--- c/src/lib/libbsp/sparc/erc32/gnatsupp/gnatsupp.c	(revision 1efa1c8389604dcf303b9acfa26c0ae60db9d9b4)
+++ 	(revision )
@@ -1,24 +1,0 @@
-/**
- * @file
- *
- * @ingroup sparc_erc32
- *
- * @brief Support for gnat/rtems interrupts and exception handling
- */
-
-/*
- * COPYRIGHT (c) 1999.
- * European Space Agency.
- *
- * The license and distribution terms for this file may be
- * found in the file LICENSE in this distribution or at
- * http://www.rtems.org/license/LICENSE.
- */
-
-#include <bsp/gnatcommon.h>
-
-void
-__gnat_install_handler (void)
-{
-  __gnat_install_handler_common (0x1d, 0x15);
-}
Index: c/src/lib/libbsp/sparc/leon2/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/leon2/Makefile.am	(revision 1efa1c8389604dcf303b9acfa26c0ae60db9d9b4)
+++ c/src/lib/libbsp/sparc/leon2/Makefile.am	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
@@ -37,5 +37,5 @@
 
 # gnatsupp
-librtemsbsp_a_SOURCES += gnatsupp/gnatsupp.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/leon2/gnatsupp/gnatsupp.c
 librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/shared/gnatcommon.c
 # console
Index: src/lib/libbsp/sparc/leon2/gnatsupp/gnatsupp.c
===================================================================
--- c/src/lib/libbsp/sparc/leon2/gnatsupp/gnatsupp.c	(revision 1efa1c8389604dcf303b9acfa26c0ae60db9d9b4)
+++ 	(revision )
@@ -1,30 +1,0 @@
-/**
- * @file
- *
- * @ingroup sparc_leon2
- *
- * @brief Support for gnat/rtems iterrupts and exception handling
- */
-
-/*
- * COPYRIGHT (c) 1999.
- * European Space Agency.
- *
- * The license and distribution terms for this file may be
- * found in the file LICENSE in this distribution or at
- * http://www.rtems.org/license/LICENSE.
- *
- */
-
-#include <bsp/gnatcommon.h>
-
-/*
- *  Avoid trap 0x18 which is used by the clock tick, and
- *  0x12 (UART B interrupt) which is used by the stub.
- */
-
-void
-__gnat_install_handler (void)
-{
-  __gnat_install_handler_common (0x18, 0x12);
-}
Index: c/src/lib/libbsp/sparc/leon3/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/leon3/Makefile.am	(revision 1efa1c8389604dcf303b9acfa26c0ae60db9d9b4)
+++ c/src/lib/libbsp/sparc/leon3/Makefile.am	(revision 96faf12a24bf32f8068025d875aa21f4654b570a)
@@ -41,5 +41,5 @@
 
 # gnatsupp
-librtemsbsp_a_SOURCES += gnatsupp/gnatsupp.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/leon3/gnatsupp/gnatsupp.c
 librtemsbsp_a_SOURCES += ../../../../../../bsps/sparc/shared/gnatcommon.c
 # AMBA bus
Index: src/lib/libbsp/sparc/leon3/gnatsupp/gnatsupp.c
===================================================================
--- c/src/lib/libbsp/sparc/leon3/gnatsupp/gnatsupp.c	(revision 1efa1c8389604dcf303b9acfa26c0ae60db9d9b4)
+++ 	(revision )
@@ -1,30 +1,0 @@
-/**
- * @file
- *
- * @ingroup sparc_leon3
- *
- * @brief Support for gnat/rtems interrupts and exception handling
- */
-
-/*
- * COPYRIGHT (c) 1999.
- * European Space Agency.
- *
- * The license and distribution terms for this file may be
- * found in the file LICENSE in this distribution or at
- * http://www.rtems.org/license/LICENSE.
- *
- */
-
-#include <bsp/gnatcommon.h>
-
-/*
- *  Avoid trap 0x18 which is used by the clock tick, and
- *  0x12 (UART B interrupt) which is used by the stub.
- */
-
-void
-__gnat_install_handler (void)
-{
-  __gnat_install_handler_common (0x18, 0x12);
-}