Index: cpukit/posix/include/rtems/posix/condimpl.h
===================================================================
--- cpukit/posix/include/rtems/posix/condimpl.h	(revision 10e40002219520651e5f0f2ed6388181f854895c)
+++ cpukit/posix/include/rtems/posix/condimpl.h	(revision 127c20ebd7ec45be2849c82437ba5e33ebf1fd46)
@@ -135,6 +135,5 @@
   pthread_cond_t            *cond,
   pthread_mutex_t           *mutex,
-  Watchdog_Interval          timeout,
-  bool                       already_timedout
+  const struct timespec     *abstime
 );
 
Index: cpukit/posix/src/condtimedwait.c
===================================================================
--- cpukit/posix/src/condtimedwait.c	(revision 10e40002219520651e5f0f2ed6388181f854895c)
+++ cpukit/posix/src/condtimedwait.c	(revision 127c20ebd7ec45be2849c82437ba5e33ebf1fd46)
@@ -32,31 +32,8 @@
 )
 {
-  Watchdog_Interval                            ticks;
-  bool                                         already_timedout;
-  TOD_Absolute_timeout_conversion_results  status;
-
-  /*
-   *  POSIX requires that blocking calls with timeouts that take
-   *  an absolute timeout must ignore issues with the absolute
-   *  time provided if the operation would otherwise succeed.
-   *  So we check the abstime provided, and hold on to whether it
-   *  is valid or not.  If it isn't correct and in the future,
-   *  then we do a polling operation and convert the UNSATISFIED
-   *  status into the appropriate error.
-   */
-  already_timedout = false;
-  status = _TOD_Absolute_timeout_to_ticks(abstime, &ticks);
-  if ( status == TOD_ABSOLUTE_TIMEOUT_INVALID )
-    return EINVAL;
-
-  if ( status == TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST ||
-       status == TOD_ABSOLUTE_TIMEOUT_IS_NOW )
-    already_timedout = true;
-
   return _POSIX_Condition_variables_Wait_support(
     cond,
     mutex,
-    ticks,
-    already_timedout
+    abstime
   );
 }
Index: cpukit/posix/src/condwait.c
===================================================================
--- cpukit/posix/src/condwait.c	(revision 10e40002219520651e5f0f2ed6388181f854895c)
+++ cpukit/posix/src/condwait.c	(revision 127c20ebd7ec45be2849c82437ba5e33ebf1fd46)
@@ -33,6 +33,5 @@
     cond,
     mutex,
-    WATCHDOG_NO_TIMEOUT,
-    false
+    NULL
   );
 }
Index: cpukit/posix/src/condwaitsupp.c
===================================================================
--- cpukit/posix/src/condwaitsupp.c	(revision 10e40002219520651e5f0f2ed6388181f854895c)
+++ cpukit/posix/src/condwaitsupp.c	(revision 127c20ebd7ec45be2849c82437ba5e33ebf1fd46)
@@ -31,6 +31,5 @@
   pthread_cond_t            *cond,
   pthread_mutex_t           *mutex,
-  Watchdog_Interval          timeout,
-  bool                       already_timedout
+  const struct timespec     *abstime
 )
 {
@@ -41,4 +40,7 @@
   Per_CPU_Control                   *cpu_self;
   Thread_Control                    *executing;
+  Watchdog_Interval                  timeout;
+  bool                               already_timedout;
+  TOD_Absolute_timeout_conversion_results  status;
 
   if ( mutex == NULL ) {
@@ -50,4 +52,30 @@
   if ( the_cond == NULL ) {
     return EINVAL;
+  }
+
+  already_timedout = false;
+
+  if ( abstime != NULL ) {
+    /*
+     *  POSIX requires that blocking calls with timeouts that take
+     *  an absolute timeout must ignore issues with the absolute
+     *  time provided if the operation would otherwise succeed.
+     *  So we check the abstime provided, and hold on to whether it
+     *  is valid or not.  If it isn't correct and in the future,
+     *  then we do a polling operation and convert the UNSATISFIED
+     *  status into the appropriate error.
+     */
+    status = _TOD_Absolute_timeout_to_ticks( abstime, &timeout );
+    if ( status == TOD_ABSOLUTE_TIMEOUT_INVALID )
+      return EINVAL;
+
+    if ( status == TOD_ABSOLUTE_TIMEOUT_IS_IN_PAST ||
+        status == TOD_ABSOLUTE_TIMEOUT_IS_NOW ) {
+      already_timedout = true;
+    } else {
+      _Thread_queue_Context_set_relative_timeout( &queue_context, timeout );
+    }
+  } else {
+    _Thread_queue_Context_set_no_timeout( &queue_context );
   }
 
@@ -69,6 +97,4 @@
   if ( !already_timedout ) {
     _Thread_queue_Context_set_expected_level( &queue_context, 2 );
-    _Thread_queue_Context_set_timeout( &queue_context, timeout );
-    _Thread_queue_Context_set_discipline( &queue_context, WATCHDOG_RELATIVE );
     _Thread_queue_Enqueue_critical(
       &the_cond->Wait_queue.Queue,